/* drawfigure.cpp 
 *
 * function to display Figured Bass figures on score
 * for Denemo, a gtk+ frontend to GNU Lilypond 
 * 
 * (c) 2003 Richard Shann <richard.shann@virgin.net>
 */

#include "utils.h"
#include <denemo/denemo.h>
#include <string.h>

void draw_figure(GdkPixmap *pixmap, GdkGC *gc, GdkFont *font,
    		gint xx, gint y, mudelaobject *theobj)
{
  static GdkFont *figurefont = NULL;
  gchar *text=NULL;
  gint length = 0;
  if(theobj->type == FIGURE) {
    text = ((chord *)theobj->object)->figure->str;
    length = ((chord *)theobj->object)->figure->len;
  }else if(theobj->type == CHORD) {
    text = ((chord *)theobj->object)->figure->str;
    length = ((chord *)theobj->object)->figure->len;
  }
#ifdef DEBUG
  g_print("%s, %d\n", text, length);
#endif
  
  if(!figurefont) {
    figurefont = gdk_fontset_load
      ("-*-helvetica-medium-r-normal-*-12-*-*-*-*-*-iso8859-*");
    if (figurefont)
      figurefont = font;
  }
  gdk_draw_text(pixmap, figurefont, gc, xx, y, text, length);

}
	  
   
