/* figure.cpp
 *
 * Functions for the manipulations of figured basses
 *
 * for Denemo, a gtk+ frontend for GNU Lilypond
 * (c) 2003 Richard Shann
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "chordops.h"
#include "calculatepositions.h"
#include "commandfuncs.h"
#include "contexts.h"
#include "figure.h"
#include "dialogs.h"
#include "draw.h"
#include "objops.h"
#include "staffops.h"
#include "utils.h"

struct callbackdata {
  struct scoreinfo * si;
  GtkWidget *entry;
};

void insertfigure(GtkWidget *widget, gpointer data)
{
  struct callbackdata *cbdata = (struct callbackdata *)data;
  struct scoreinfo *si = cbdata->si;
  mudelaobject *curObj = (mudelaobject *)si->currentobject ? 
    (mudelaobject *)si->currentobject->data : NULL;
  gchar *figure = (gchar*)gtk_entry_get_text(GTK_ENTRY(cbdata->entry));
  if(curObj && curObj->type == CHORD) {
    if(!((chord *)curObj->object)->figure)
      ((chord *)curObj->object)->figure = g_string_new(figure);
    else
      g_string_assign(((chord *)curObj->object)->figure,figure);
  }
  si->has_figures = TRUE;
  si->haschanged = TRUE;
  gtk_widget_draw (si->scorearea, NULL);
}

void figure_insert(gpointer callback_data, guint callback_action, 
    		  GtkWidget *widget)
{
  GtkWidget *dialog;
  GtkWidget *entry;
  GtkWidget *label;
  GtkWidget *okbutton;
  GtkWidget *cancelbutton;
  
  static struct callbackdata cbdata;
  struct scoreinfo *si = (struct scoreinfo *)callback_data;
  mudelaobject *curObj = (mudelaobject *)si->currentobject ? 
    (mudelaobject *)si->currentobject->data : NULL;
  dialog = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog), _("Insert/Edit Figure"));
  

  label = gtk_label_new (_("Insert/Edit Figure:"));
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), label,
	                        TRUE, TRUE, 0);
  gtk_widget_show (label);
	
  entry = gtk_entry_new();
  if(curObj && curObj->type == CHORD && ((chord *)curObj->object)->figure)	
    gtk_entry_set_text(GTK_ENTRY(entry),((chord *)curObj->object)->figure->str);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), entry,
                                      TRUE, TRUE, 0);      
  gtk_widget_show (entry);

 
  okbutton = gtk_button_new_with_label (_("OK"));
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area), okbutton,
		      TRUE, TRUE, 0);
  cbdata.si = si;
  cbdata.entry = entry;

  gtk_signal_connect (GTK_OBJECT (okbutton), "clicked",
		      GTK_SIGNAL_FUNC (insertfigure), &cbdata);
  gtk_signal_connect_object (GTK_OBJECT (okbutton), "clicked",
			     GTK_SIGNAL_FUNC(gtk_widget_destroy), 
			     GTK_OBJECT (dialog));
  gtk_widget_show (okbutton);
  
  cancelbutton = gtk_button_new_with_label (_("Cancel"));
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),
		      cancelbutton, TRUE, TRUE, 0);
  gtk_signal_connect_object (GTK_OBJECT (cancelbutton), "clicked",
			     GTK_SIGNAL_FUNC(gtk_widget_destroy), 
			     GTK_OBJECT (dialog));
  gtk_widget_show (cancelbutton);
  gtk_widget_grab_focus (entry);
  gtk_window_set_modal (GTK_WINDOW (dialog), TRUE);
  gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_MOUSE);
  gtk_widget_show (dialog);
  
}

	  
      
  
